//	Define these preprocessor directives as required for the type of database being used.
#define DATABASE_MSACCESS
//#define DATABASE_SQLSERVER

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinToolbars;
using System.Data.OleDb;
using Infragistics.Win.UltraWinEditors;

namespace Infragistics.Win.UltraWinSchedule.Samples
{
	#region frmMain class
	/// <summary>
	/// Main dialog for the UltraWinSchedule DB Demo Application.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		#region Member variables

		private Infragistics.Win.UltraWinSchedule.UltraCalendarInfo ultraCalendarInfo1;
		private Infragistics.Win.UltraWinSchedule.UltraCalendarLook ultraCalendarLook1;
		private Infragistics.Win.UltraWinSchedule.UltraMonthViewMulti ultraMonthViewMulti1;
		private System.Windows.Forms.Panel frmMain_Fill_Panel;
		private System.Windows.Forms.Panel pnlLeft;
		private System.Windows.Forms.Panel pnlMain;
		private System.Windows.Forms.Splitter splitter1;
		private Infragistics.Win.UltraWinSchedule.UltraDayView ultraDayView1;
		private Infragistics.Win.UltraWinSchedule.UltraMonthViewSingle ultraMonthViewSingle1;
		private Infragistics.Win.UltraWinSchedule.UltraWeekView ultraWeekView1;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsManager ultraToolbarsManager1;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _frmAppointmentGrouping_Toolbars_Dock_Area_Top;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _frmAppointmentGrouping_Toolbars_Dock_Area_Bottom;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _frmAppointmentGrouping_Toolbars_Dock_Area_Left;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _frmAppointmentGrouping_Toolbars_Dock_Area_Right;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Splitter splitter2;
		private Infragistics.Win.IGControls.IGContextMenu contextMenu1;
		private Infragistics.Win.IGControls.IGMenuItem menuItem_ModifyOwner;
		private Infragistics.Win.IGControls.IGMenuItem menuItem_RemoveOwner;
		private System.Windows.Forms.Panel pnlOwners;
        private UltraTimelineView ultraTimelineView1;

		private WinScheduleDatabaseSupportBase _databaseSupport = null;

		#endregion Member variables

		#region Constructor
		/// <summary>
		/// Creates a new instance of the <see cref="frmMain"/> class.
		/// </summary>
		public frmMain()
		{
			this.InitializeComponent();
			this.InitializeUI();
		}
		#endregion Constructor

		#region Windows Form Designer generated code

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}

				//	Dispose of the WinScheduleDatabaseSupportBase object
				if ( this._databaseSupport != null )
				{
					this._databaseSupport.Dispose();
					this._databaseSupport = null;
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            Infragistics.Win.UltraWinSchedule.DateInterval dateInterval1 = new Infragistics.Win.UltraWinSchedule.DateInterval();
            Infragistics.Win.UltraWinSchedule.TimeInterval timeInterval1 = new Infragistics.Win.UltraWinSchedule.TimeInterval();
            Infragistics.Win.UltraWinToolbars.OptionSet optionSet1 = new Infragistics.Win.UltraWinToolbars.OptionSet("DateButtons");
            Infragistics.Win.UltraWinToolbars.OptionSet optionSet2 = new Infragistics.Win.UltraWinToolbars.OptionSet("ViewStyle");
            Infragistics.Win.UltraWinToolbars.UltraToolbar ultraToolbar1 = new Infragistics.Win.UltraWinToolbars.UltraToolbar("tlbMainMenu");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool1 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("menuFile");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool2 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("menuData");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool3 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("menuView");
            Infragistics.Win.UltraWinToolbars.UltraToolbar ultraToolbar2 = new Infragistics.Win.UltraWinToolbars.UltraToolbar("tlbMainToolbar");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool4 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("New");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool1 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("Day", "DateButtons");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool2 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("Week", "DateButtons");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool3 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("Month", "DateButtons");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool20 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("TimeLine", "DateButtons");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool5 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("menuFile");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool1 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuMain_File_Exit");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool2 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuMain_File_Exit");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool6 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("New");
            Infragistics.Win.Appearance appearance1 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool3 = new Infragistics.Win.UltraWinToolbars.ButtonTool("AddOwner");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool4 = new Infragistics.Win.UltraWinToolbars.ButtonTool("AddAppointment");
            Infragistics.Win.Appearance appearance2 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool5 = new Infragistics.Win.UltraWinToolbars.ButtonTool("AddOwner");
            Infragistics.Win.Appearance appearance3 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool4 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("Day", "DateButtons");
            Infragistics.Win.Appearance appearance4 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool5 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("Week", "DateButtons");
            Infragistics.Win.Appearance appearance5 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool6 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("Month", "DateButtons");
            Infragistics.Win.Appearance appearance6 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool7 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("menuView");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool7 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_Standard", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool8 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_Office2003", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool9 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_VS2005", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool8 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("Office2007");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool10 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_Standard", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool11 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_Office2003", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool12 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_VS2005", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool9 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("menuData");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool10 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("menuQueries");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool6 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuMain_Data_UpdateOwnersTable");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool7 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuMain_Data_UpdateAppointmentsTable");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool8 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuMain_Data_UpdateOwnersTable");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool9 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuMain_Data_UpdateAppointmentsTable");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool11 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("menuQueries");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool10 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuQueries_AllOwners");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool11 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuQueries_AllAppointments");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool12 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuQueries_AppointmentsByOwner");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool13 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuQueries_AppointmentsByOwner");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool14 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuQueries_AllAppointments");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool15 = new Infragistics.Win.UltraWinToolbars.ButtonTool("menuQueries_AllOwners");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool13 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_Office2007_Blue", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool14 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_Office2007_Black", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool12 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("Office2007");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool15 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_Office2007_Blue", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool16 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_Office2007_Black", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool17 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_Office2007_Silver", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool18 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("menuMain_View_Office2007_Silver", "ViewStyle");
            Infragistics.Win.UltraWinToolbars.StateButtonTool stateButtonTool19 = new Infragistics.Win.UltraWinToolbars.StateButtonTool("TimeLine", "DateButtons");
            Infragistics.Win.Appearance appearance7 = new Infragistics.Win.Appearance();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(frmMain));
            this.ultraCalendarInfo1 = new Infragistics.Win.UltraWinSchedule.UltraCalendarInfo(this.components);
            this.ultraCalendarLook1 = new Infragistics.Win.UltraWinSchedule.UltraCalendarLook(this.components);
            this.ultraMonthViewMulti1 = new Infragistics.Win.UltraWinSchedule.UltraMonthViewMulti();
            this.frmMain_Fill_Panel = new System.Windows.Forms.Panel();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.pnlMain = new System.Windows.Forms.Panel();
            this.ultraTimelineView1 = new Infragistics.Win.UltraWinSchedule.UltraTimelineView();
            this.ultraWeekView1 = new Infragistics.Win.UltraWinSchedule.UltraWeekView();
            this.ultraMonthViewSingle1 = new Infragistics.Win.UltraWinSchedule.UltraMonthViewSingle();
            this.ultraDayView1 = new Infragistics.Win.UltraWinSchedule.UltraDayView();
            this.pnlLeft = new System.Windows.Forms.Panel();
            this.pnlOwners = new System.Windows.Forms.Panel();
            this.splitter2 = new System.Windows.Forms.Splitter();
            this.ultraToolbarsManager1 = new Infragistics.Win.UltraWinToolbars.UltraToolbarsManager(this.components);
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Top = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Bottom = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Left = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Right = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
            this.contextMenu1 = new Infragistics.Win.IGControls.IGContextMenu();
            ((System.ComponentModel.ISupportInitialize)(this.ultraMonthViewMulti1)).BeginInit();
            this.frmMain_Fill_Panel.SuspendLayout();
            this.pnlMain.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.ultraTimelineView1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.ultraWeekView1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.ultraMonthViewSingle1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.ultraDayView1)).BeginInit();
            this.pnlLeft.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.ultraToolbarsManager1)).BeginInit();
            this.SuspendLayout();
            // 
            // ultraCalendarInfo1
            // 
            this.ultraCalendarInfo1.AllowRecurringAppointments = true;
            this.ultraCalendarInfo1.DataBindingsForAppointments.BindingContextControl = this;
            this.ultraCalendarInfo1.DataBindingsForOwners.BindingContextControl = this;
            this.ultraCalendarInfo1.ValidateAppointment += new Infragistics.Win.UltraWinSchedule.ValidateAppointmentEventHandler(this.ultraCalendarInfo1_ValidateAppointment);
            // 
            // ultraCalendarLook1
            // 
            this.ultraCalendarLook1.ViewStyle = Infragistics.Win.UltraWinSchedule.ViewStyle.Office2007;
            // 
            // ultraMonthViewMulti1
            // 
            this.ultraMonthViewMulti1.BackColor = System.Drawing.SystemColors.Window;
            this.ultraMonthViewMulti1.CalendarInfo = this.ultraCalendarInfo1;
            this.ultraMonthViewMulti1.CalendarLook = this.ultraCalendarLook1;
            resources.ApplyResources(this.ultraMonthViewMulti1, "ultraMonthViewMulti1");
            this.ultraMonthViewMulti1.MonthOrientation = Infragistics.Win.UltraWinSchedule.MonthOrientation.DownThenAcross;
            this.ultraMonthViewMulti1.Name = "ultraMonthViewMulti1";
            // 
            // frmMain_Fill_Panel
            // 
            this.frmMain_Fill_Panel.Controls.Add(this.splitter1);
            this.frmMain_Fill_Panel.Controls.Add(this.pnlMain);
            this.frmMain_Fill_Panel.Controls.Add(this.pnlLeft);
            this.frmMain_Fill_Panel.Cursor = System.Windows.Forms.Cursors.Default;
            resources.ApplyResources(this.frmMain_Fill_Panel, "frmMain_Fill_Panel");
            this.frmMain_Fill_Panel.Name = "frmMain_Fill_Panel";
            // 
            // splitter1
            // 
            this.splitter1.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(0)))), ((int)(((byte)(0)))), ((int)(((byte)(128)))));
            resources.ApplyResources(this.splitter1, "splitter1");
            this.splitter1.Name = "splitter1";
            this.splitter1.TabStop = false;
            // 
            // pnlMain
            // 
            this.pnlMain.Controls.Add(this.ultraTimelineView1);
            this.pnlMain.Controls.Add(this.ultraWeekView1);
            this.pnlMain.Controls.Add(this.ultraMonthViewSingle1);
            this.pnlMain.Controls.Add(this.ultraDayView1);
            resources.ApplyResources(this.pnlMain, "pnlMain");
            this.pnlMain.Name = "pnlMain";
            // 
            // ultraTimelineView1
            // 
            this.ultraTimelineView1.AdditionalIntervals.Add(dateInterval1);
            this.ultraTimelineView1.CalendarInfo = this.ultraCalendarInfo1;
            this.ultraTimelineView1.CalendarLook = this.ultraCalendarLook1;
            this.ultraTimelineView1.ColumnWidth = 0;
            resources.ApplyResources(this.ultraTimelineView1, "ultraTimelineView1");
            this.ultraTimelineView1.Name = "ultraTimelineView1";
            this.ultraTimelineView1.PrimaryInterval = timeInterval1;
            // 
            // ultraWeekView1
            // 
            this.ultraWeekView1.CalendarInfo = this.ultraCalendarInfo1;
            this.ultraWeekView1.CalendarLook = this.ultraCalendarLook1;
            resources.ApplyResources(this.ultraWeekView1, "ultraWeekView1");
            this.ultraWeekView1.Name = "ultraWeekView1";
            // 
            // ultraMonthViewSingle1
            // 
            this.ultraMonthViewSingle1.CalendarInfo = this.ultraCalendarInfo1;
            this.ultraMonthViewSingle1.CalendarLook = this.ultraCalendarLook1;
            resources.ApplyResources(this.ultraMonthViewSingle1, "ultraMonthViewSingle1");
            this.ultraMonthViewSingle1.Name = "ultraMonthViewSingle1";
            // 
            // ultraDayView1
            // 
            this.ultraDayView1.CalendarInfo = this.ultraCalendarInfo1;
            this.ultraDayView1.CalendarLook = this.ultraCalendarLook1;
            resources.ApplyResources(this.ultraDayView1, "ultraDayView1");
            this.ultraDayView1.Name = "ultraDayView1";
            // 
            // pnlLeft
            // 
            this.pnlLeft.Controls.Add(this.pnlOwners);
            this.pnlLeft.Controls.Add(this.splitter2);
            this.pnlLeft.Controls.Add(this.ultraMonthViewMulti1);
            resources.ApplyResources(this.pnlLeft, "pnlLeft");
            this.pnlLeft.Name = "pnlLeft";
            // 
            // pnlOwners
            // 
            resources.ApplyResources(this.pnlOwners, "pnlOwners");
            this.pnlOwners.BackColor = System.Drawing.Color.White;
            this.pnlOwners.Name = "pnlOwners";
            // 
            // splitter2
            // 
            this.splitter2.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(0)))), ((int)(((byte)(0)))), ((int)(((byte)(128)))));
            resources.ApplyResources(this.splitter2, "splitter2");
            this.splitter2.Name = "splitter2";
            this.splitter2.TabStop = false;
            // 
            // ultraToolbarsManager1
            // 
            this.ultraToolbarsManager1.DesignerFlags = 1;
            this.ultraToolbarsManager1.DockWithinContainer = this;
            this.ultraToolbarsManager1.DockWithinContainerBaseType = typeof(System.Windows.Forms.Form);
            this.ultraToolbarsManager1.ImageTransparentColor = System.Drawing.Color.Magenta;
            optionSet1.AllowAllUp = false;
            optionSet2.AllowAllUp = false;
            this.ultraToolbarsManager1.OptionSets.Add(optionSet1);
            this.ultraToolbarsManager1.OptionSets.Add(optionSet2);
            this.ultraToolbarsManager1.ShowFullMenusDelay = 500;
            this.ultraToolbarsManager1.Style = Infragistics.Win.UltraWinToolbars.ToolbarStyle.Office2003;
            ultraToolbar1.DockedColumn = 0;
            ultraToolbar1.DockedRow = 0;
            ultraToolbar1.IsMainMenuBar = true;
            ultraToolbar1.NonInheritedTools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
            popupMenuTool1,
            popupMenuTool2,
            popupMenuTool3});
            resources.ApplyResources(ultraToolbar1, "ultraToolbar1");
            ultraToolbar2.DockedColumn = 0;
            ultraToolbar2.DockedRow = 1;
            popupMenuTool4.InstanceProps.IsFirstInGroup = true;
            stateButtonTool1.Checked = true;
            stateButtonTool1.InstanceProps.IsFirstInGroup = true;
            ultraToolbar2.NonInheritedTools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
            popupMenuTool4,
            stateButtonTool1,
            stateButtonTool2,
            stateButtonTool3,
            stateButtonTool20});
            resources.ApplyResources(ultraToolbar2, "ultraToolbar2");
            this.ultraToolbarsManager1.Toolbars.AddRange(new Infragistics.Win.UltraWinToolbars.UltraToolbar[] {
            ultraToolbar1,
            ultraToolbar2});
            resources.ApplyResources(popupMenuTool5.SharedPropsInternal, "popupMenuTool5.SharedPropsInternal");
            popupMenuTool5.Tools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
            buttonTool1});
            popupMenuTool5.ForceApplyResources = "SharedPropsInternal";
            resources.ApplyResources(buttonTool2.SharedPropsInternal, "buttonTool2.SharedPropsInternal");
            buttonTool2.ForceApplyResources = "SharedPropsInternal";
            appearance1.Image = ((object)(resources.GetObject("appearance1.Image")));
            popupMenuTool6.SharedPropsInternal.AppearancesSmall.Appearance = appearance1;
            resources.ApplyResources(popupMenuTool6.SharedPropsInternal, "popupMenuTool6.SharedPropsInternal");
            popupMenuTool6.SharedPropsInternal.DisplayStyle = Infragistics.Win.UltraWinToolbars.ToolDisplayStyle.ImageAndText;
            popupMenuTool6.Tools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
            buttonTool3});
            popupMenuTool6.ForceApplyResources = "SharedPropsInternal";
            appearance2.Image = ((object)(resources.GetObject("appearance2.Image")));
            buttonTool4.SharedPropsInternal.AppearancesSmall.Appearance = appearance2;
            resources.ApplyResources(buttonTool4.SharedPropsInternal, "buttonTool4.SharedPropsInternal");
            buttonTool4.SharedPropsInternal.DisplayStyle = Infragistics.Win.UltraWinToolbars.ToolDisplayStyle.ImageAndText;
            buttonTool4.ForceApplyResources = "SharedPropsInternal";
            appearance3.Image = ((object)(resources.GetObject("appearance3.Image")));
            buttonTool5.SharedPropsInternal.AppearancesSmall.Appearance = appearance3;
            resources.ApplyResources(buttonTool5.SharedPropsInternal, "buttonTool5.SharedPropsInternal");
            buttonTool5.SharedPropsInternal.DisplayStyle = Infragistics.Win.UltraWinToolbars.ToolDisplayStyle.ImageAndText;
            buttonTool5.ForceApplyResources = "SharedPropsInternal";
            stateButtonTool4.Checked = true;
            stateButtonTool4.OptionSetKey = "DateButtons";
            appearance4.Image = ((object)(resources.GetObject("appearance4.Image")));
            stateButtonTool4.SharedPropsInternal.AppearancesSmall.Appearance = appearance4;
            resources.ApplyResources(stateButtonTool4.SharedPropsInternal, "stateButtonTool4.SharedPropsInternal");
            stateButtonTool4.SharedPropsInternal.DisplayStyle = Infragistics.Win.UltraWinToolbars.ToolDisplayStyle.ImageAndText;
            stateButtonTool4.ForceApplyResources = "SharedPropsInternal";
            stateButtonTool5.OptionSetKey = "DateButtons";
            appearance5.Image = ((object)(resources.GetObject("appearance5.Image")));
            stateButtonTool5.SharedPropsInternal.AppearancesSmall.Appearance = appearance5;
            resources.ApplyResources(stateButtonTool5.SharedPropsInternal, "stateButtonTool5.SharedPropsInternal");
            stateButtonTool5.SharedPropsInternal.DisplayStyle = Infragistics.Win.UltraWinToolbars.ToolDisplayStyle.ImageAndText;
            stateButtonTool5.ForceApplyResources = "SharedPropsInternal";
            stateButtonTool6.OptionSetKey = "DateButtons";
            appearance6.Image = ((object)(resources.GetObject("appearance6.Image")));
            stateButtonTool6.SharedPropsInternal.AppearancesSmall.Appearance = appearance6;
            resources.ApplyResources(stateButtonTool6.SharedPropsInternal, "stateButtonTool6.SharedPropsInternal");
            stateButtonTool6.SharedPropsInternal.DisplayStyle = Infragistics.Win.UltraWinToolbars.ToolDisplayStyle.ImageAndText;
            stateButtonTool6.ForceApplyResources = "SharedPropsInternal";
            resources.ApplyResources(popupMenuTool7.SharedPropsInternal, "popupMenuTool7.SharedPropsInternal");
            stateButtonTool7.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            stateButtonTool8.Checked = true;
            stateButtonTool8.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            stateButtonTool9.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            popupMenuTool7.Tools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
            stateButtonTool7,
            stateButtonTool8,
            stateButtonTool9,
            popupMenuTool8});
            popupMenuTool7.ForceApplyResources = "SharedPropsInternal";
            stateButtonTool10.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            stateButtonTool10.OptionSetKey = "ViewStyle";
            resources.ApplyResources(stateButtonTool10.SharedPropsInternal, "stateButtonTool10.SharedPropsInternal");
            stateButtonTool10.ForceApplyResources = "SharedPropsInternal";
            stateButtonTool11.Checked = true;
            stateButtonTool11.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            stateButtonTool11.OptionSetKey = "ViewStyle";
            resources.ApplyResources(stateButtonTool11.SharedPropsInternal, "stateButtonTool11.SharedPropsInternal");
            stateButtonTool11.ForceApplyResources = "SharedPropsInternal";
            stateButtonTool12.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            stateButtonTool12.OptionSetKey = "ViewStyle";
            resources.ApplyResources(stateButtonTool12.SharedPropsInternal, "stateButtonTool12.SharedPropsInternal");
            stateButtonTool12.ForceApplyResources = "SharedPropsInternal";
            resources.ApplyResources(popupMenuTool9.SharedPropsInternal, "popupMenuTool9.SharedPropsInternal");
            popupMenuTool9.Tools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
            popupMenuTool10,
            buttonTool6,
            buttonTool7});
            popupMenuTool9.ForceApplyResources = "SharedPropsInternal";
            resources.ApplyResources(buttonTool8.SharedPropsInternal, "buttonTool8.SharedPropsInternal");
            buttonTool8.ForceApplyResources = "SharedPropsInternal";
            resources.ApplyResources(buttonTool9.SharedPropsInternal, "buttonTool9.SharedPropsInternal");
            buttonTool9.ForceApplyResources = "SharedPropsInternal";
            resources.ApplyResources(popupMenuTool11.SharedPropsInternal, "popupMenuTool11.SharedPropsInternal");
            popupMenuTool11.Tools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
            buttonTool10,
            buttonTool11,
            buttonTool12});
            popupMenuTool11.ForceApplyResources = "SharedPropsInternal";
            resources.ApplyResources(buttonTool13.SharedPropsInternal, "buttonTool13.SharedPropsInternal");
            buttonTool13.ForceApplyResources = "SharedPropsInternal";
            resources.ApplyResources(buttonTool14.SharedPropsInternal, "buttonTool14.SharedPropsInternal");
            buttonTool14.ForceApplyResources = "SharedPropsInternal";
            resources.ApplyResources(buttonTool15.SharedPropsInternal, "buttonTool15.SharedPropsInternal");
            buttonTool15.ForceApplyResources = "SharedPropsInternal";
            stateButtonTool13.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            stateButtonTool13.OptionSetKey = "ViewStyle";
            resources.ApplyResources(stateButtonTool13.SharedPropsInternal, "stateButtonTool13.SharedPropsInternal");
            stateButtonTool13.ForceApplyResources = "SharedPropsInternal";
            stateButtonTool14.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            stateButtonTool14.OptionSetKey = "ViewStyle";
            resources.ApplyResources(stateButtonTool14.SharedPropsInternal, "stateButtonTool14.SharedPropsInternal");
            stateButtonTool14.ForceApplyResources = "SharedPropsInternal";
            resources.ApplyResources(popupMenuTool12.SharedPropsInternal, "popupMenuTool12.SharedPropsInternal");
            stateButtonTool15.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            stateButtonTool16.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            stateButtonTool17.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            popupMenuTool12.Tools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
            stateButtonTool15,
            stateButtonTool16,
            stateButtonTool17});
            popupMenuTool12.ForceApplyResources = "SharedPropsInternal";
            stateButtonTool18.MenuDisplayStyle = Infragistics.Win.UltraWinToolbars.StateButtonMenuDisplayStyle.DisplayCheckmark;
            stateButtonTool18.OptionSetKey = "ViewStyle";
            resources.ApplyResources(stateButtonTool18.SharedPropsInternal, "stateButtonTool18.SharedPropsInternal");
            stateButtonTool18.ForceApplyResources = "SharedPropsInternal";
            stateButtonTool19.OptionSetKey = "DateButtons";
            appearance7.Image = ((object)(resources.GetObject("appearance7.Image")));
            stateButtonTool19.SharedPropsInternal.AppearancesSmall.Appearance = appearance7;
            resources.ApplyResources(stateButtonTool19.SharedPropsInternal, "stateButtonTool19.SharedPropsInternal");
            stateButtonTool19.SharedPropsInternal.DisplayStyle = Infragistics.Win.UltraWinToolbars.ToolDisplayStyle.ImageAndText;
            stateButtonTool19.ForceApplyResources = "SharedPropsInternal";
            this.ultraToolbarsManager1.Tools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
            popupMenuTool5,
            buttonTool2,
            popupMenuTool6,
            buttonTool4,
            buttonTool5,
            stateButtonTool4,
            stateButtonTool5,
            stateButtonTool6,
            popupMenuTool7,
            stateButtonTool10,
            stateButtonTool11,
            stateButtonTool12,
            popupMenuTool9,
            buttonTool8,
            buttonTool9,
            popupMenuTool11,
            buttonTool13,
            buttonTool14,
            buttonTool15,
            stateButtonTool13,
            stateButtonTool14,
            popupMenuTool12,
            stateButtonTool18,
            stateButtonTool19});
            this.ultraToolbarsManager1.ToolClick += new Infragistics.Win.UltraWinToolbars.ToolClickEventHandler(this.ultraToolbarsManager1_ToolClick);
            // 
            // _frmAppointmentGrouping_Toolbars_Dock_Area_Top
            // 
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Top.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Top.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(158)))), ((int)(((byte)(190)))), ((int)(((byte)(245)))));
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Top.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Top;
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Top.ForeColor = System.Drawing.SystemColors.ControlText;
            resources.ApplyResources(this._frmAppointmentGrouping_Toolbars_Dock_Area_Top, "_frmAppointmentGrouping_Toolbars_Dock_Area_Top");
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Top.Name = "_frmAppointmentGrouping_Toolbars_Dock_Area_Top";
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Top.ToolbarsManager = this.ultraToolbarsManager1;
            // 
            // _frmAppointmentGrouping_Toolbars_Dock_Area_Bottom
            // 
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Bottom.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Bottom.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(158)))), ((int)(((byte)(190)))), ((int)(((byte)(245)))));
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Bottom.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Bottom;
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Bottom.ForeColor = System.Drawing.SystemColors.ControlText;
            resources.ApplyResources(this._frmAppointmentGrouping_Toolbars_Dock_Area_Bottom, "_frmAppointmentGrouping_Toolbars_Dock_Area_Bottom");
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Bottom.Name = "_frmAppointmentGrouping_Toolbars_Dock_Area_Bottom";
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Bottom.ToolbarsManager = this.ultraToolbarsManager1;
            // 
            // _frmAppointmentGrouping_Toolbars_Dock_Area_Left
            // 
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Left.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Left.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(158)))), ((int)(((byte)(190)))), ((int)(((byte)(245)))));
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Left.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Left;
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Left.ForeColor = System.Drawing.SystemColors.ControlText;
            resources.ApplyResources(this._frmAppointmentGrouping_Toolbars_Dock_Area_Left, "_frmAppointmentGrouping_Toolbars_Dock_Area_Left");
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Left.Name = "_frmAppointmentGrouping_Toolbars_Dock_Area_Left";
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Left.ToolbarsManager = this.ultraToolbarsManager1;
            // 
            // _frmAppointmentGrouping_Toolbars_Dock_Area_Right
            // 
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Right.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Right.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(158)))), ((int)(((byte)(190)))), ((int)(((byte)(245)))));
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Right.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Right;
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Right.ForeColor = System.Drawing.SystemColors.ControlText;
            resources.ApplyResources(this._frmAppointmentGrouping_Toolbars_Dock_Area_Right, "_frmAppointmentGrouping_Toolbars_Dock_Area_Right");
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Right.Name = "_frmAppointmentGrouping_Toolbars_Dock_Area_Right";
            this._frmAppointmentGrouping_Toolbars_Dock_Area_Right.ToolbarsManager = this.ultraToolbarsManager1;
            // 
            // contextMenu1
            // 
            this.contextMenu1.ImageList = null;
            this.contextMenu1.Style = Infragistics.Win.IGControls.MenuStyle.OfficeXP;
            this.contextMenu1.TouchMetricsEnabled = false;
            // 
            // frmMain
            // 
            resources.ApplyResources(this, "$this");
            this.BackColor = System.Drawing.Color.White;
            this.Controls.Add(this.frmMain_Fill_Panel);
            this.Controls.Add(this._frmAppointmentGrouping_Toolbars_Dock_Area_Right);
            this.Controls.Add(this._frmAppointmentGrouping_Toolbars_Dock_Area_Left);
            this.Controls.Add(this._frmAppointmentGrouping_Toolbars_Dock_Area_Bottom);
            this.Controls.Add(this._frmAppointmentGrouping_Toolbars_Dock_Area_Top);
            this.Name = "frmMain";
            this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
            this.Load += new System.EventHandler(this.frmMain_Load);
            ((System.ComponentModel.ISupportInitialize)(this.ultraMonthViewMulti1)).EndInit();
            this.frmMain_Fill_Panel.ResumeLayout(false);
            this.pnlMain.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.ultraTimelineView1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.ultraWeekView1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.ultraMonthViewSingle1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.ultraDayView1)).EndInit();
            this.pnlLeft.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.ultraToolbarsManager1)).EndInit();
            this.ResumeLayout(false);

		}
		
		#endregion	Windows Form Designer generated code

		#region Main()
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
        { 
			//Load the IG isl File
			Infragistics.StyleLibrary.GetStyleLibrary style = new Infragistics.StyleLibrary.GetStyleLibrary();
			string islFile = style.GetIsl();
			Infragistics.Win.AppStyling.StyleManager.Load(islFile);

			Application.Run(new frmMain());
		}

		#endregion Main()

		#region Event handlers

		/// <summary>
		/// Handles the main form's Closing event
		/// </summary>
		private void frmMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			//	If the Appointments or Owners table has changes pending that have not
			//	yet been committed to the database, prompt the end user to determine
			//	whether they want to save the changes.
			if ( this.DatabaseSupport.HasAppointmentChanges ||
				 this.DatabaseSupport.HasOwnerChanges )
			{
				DialogResult result = MessageBox.Show( Properties.Resources.SaveChangesMessage, Properties.Resources.SaveChangesTitle, MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question );

				switch ( result )
				{
					case DialogResult.Cancel:
					{
						e.Cancel = true;
						break;
					}

					case DialogResult.Yes:
					{
						try
						{
							this.DatabaseSupport.UpdateAppointmentsTable();
						}
						catch( Exception ex )
						{
							MessageBox.Show( Properties.Resources.AppointmentUpdateError + ex.Message, Properties.Resources.Error, MessageBoxButtons.OK, MessageBoxIcon.Error );
						}

						try
						{
							this.DatabaseSupport.UpdateOwnersTable();
						}
						catch( Exception ex )
						{
							MessageBox.Show( Properties.Resources.OwnersUpdateError + ex.Message, Properties.Resources.Error, MessageBoxButtons.OK, MessageBoxIcon.Error );
						}

						break;
					}

				}
			}
		}

		/// <summary>
		/// Handles the UltraToolbarManager's ToolClick event.
		/// </summary>
		private void ultraToolbarsManager1_ToolClick(object sender, Infragistics.Win.UltraWinToolbars.ToolClickEventArgs e)
		{
			switch ( e.Tool.Key )
			{
				case "Day":
				{
					this.ShowScheduleControl( this.ultraDayView1 );
					break;
				}

				case "Week":
				{
					this.ShowScheduleControl( this.ultraWeekView1 );			
					break;
				}

				case "Month":
				{
					this.ShowScheduleControl( this.ultraMonthViewSingle1 );			
					break;
				}

            case "TimeLine":
                {
                    this.ShowScheduleControl( this.ultraTimelineView1 );
                    break;
                }

				case "menuMain_View_Standard":
				{
					this.ultraDayView1.Appearance.BackColor = SystemColors.Control;
					this.ultraCalendarLook1.ViewStyle = ViewStyle.Standard;
					this.ultraToolbarsManager1.Style = ToolbarStyle.OfficeXP;
					this.contextMenu1.Style = Infragistics.Win.IGControls.MenuStyle.OfficeXP;
					break;
				}

				case "menuMain_View_Office2003":
				{
					this.ultraDayView1.Appearance.BackColor = SystemColors.Control;
					this.ultraCalendarLook1.ViewStyle = ViewStyle.Office2003;
					this.ultraToolbarsManager1.Style = ToolbarStyle.Office2003;
					this.contextMenu1.Style = Infragistics.Win.IGControls.MenuStyle.Office2003;
					break;
				}

				case "menuMain_View_VS2005":
				{
					this.ultraDayView1.Appearance.BackColor = SystemColors.Control;
					this.ultraCalendarLook1.ViewStyle = ViewStyle.VisualStudio2005;
					this.ultraToolbarsManager1.Style = ToolbarStyle.VisualStudio2005;
					this.contextMenu1.Style = Infragistics.Win.IGControls.MenuStyle.VisualStudio2005;
					break;
				}

				case "menuMain_View_Office2007_Blue":
				case "menuMain_View_Office2007_Black":
				case "menuMain_View_Office2007_Silver":
				{
					this.ultraDayView1.Appearance.Reset();
					this.ultraCalendarLook1.ViewStyle = ViewStyle.Office2007;
					this.ultraToolbarsManager1.Style = ToolbarStyle.Office2007;
					this.contextMenu1.Style = Infragistics.Win.IGControls.MenuStyle.Office2007;

					if ( e.Tool.Key == "menuMain_View_Office2007_Blue" )
						Infragistics.Win.Office2007ColorTable.ColorScheme = Office2007ColorScheme.Blue;
					else
					if ( e.Tool.Key == "menuMain_View_Office2007_Black" )
						Infragistics.Win.Office2007ColorTable.ColorScheme = Office2007ColorScheme.Black;
					else
					if ( e.Tool.Key == "menuMain_View_Office2007_Silver" )
						Infragistics.Win.Office2007ColorTable.ColorScheme = Office2007ColorScheme.Silver;
					
					StateButtonTool stateButtonTool = this.ultraToolbarsManager1.Tools[e.Tool.Key] as StateButtonTool;
					stateButtonTool.Checked = true;

					//	Assign the default color scheme
					string ownerKey = "INFRAGISTICS_POWER_USER";
					if ( this.ultraCalendarInfo1.Owners.Exists(ownerKey) )
					{
						Infragistics.Win.UltraWinSchedule.Owner owner = this.ultraCalendarInfo1.Owners[ownerKey];
						owner.Outlook2007ColorScheme = this.ultraCalendarLook1.Outlook2007ColorSchemes.DefaultScheme;
					}

					break;
				}

				case "AddOwner":
				{
					frmOwner frmOwner = new frmOwner( this.ultraCalendarInfo1 );
					frmOwner.ShowMe( null );
					if ( frmOwner.DialogResult == DialogResult.OK )
					{
						Owner newOwner = this.ultraCalendarInfo1.Owners.Add( frmOwner.Key, frmOwner.OwnerName );
						newOwner.EmailAddress = frmOwner.EMailAddress;
						newOwner.Visible = frmOwner.OwnerVisible;
						newOwner.Locked = frmOwner.Locked;
						this.AddCheckboxForOwner( newOwner );
					}

					break;
				}

				case "menuMain_Data_UpdateAppointmentsTable":
				{
					try
					{
						this.DatabaseSupport.UpdateAppointmentsTable();
					}
					catch( Exception ex )
					{
						MessageBox.Show( Properties.Resources.AppointmentUpdateError + ex.Message, Properties.Resources.Error, MessageBoxButtons.OK, MessageBoxIcon.Error );
					}

					break;
				}

				case "menuMain_Data_UpdateOwnersTable":
				{
					try
					{
						this.DatabaseSupport.UpdateOwnersTable();
					}
					catch( Exception ex )
					{
						MessageBox.Show( Properties.Resources.OwnersUpdateError + ex.Message, Properties.Resources.Error, MessageBoxButtons.OK, MessageBoxIcon.Error );
					}

					break;
				}

				case "menuQueries_AllAppointments":
				case "menuQueries_AllOwners":
				case "menuQueries_AppointmentsByOwner":
				{
					QueryType queryType = QueryType.AllAppointments;
					if ( e.Tool.Key == "menuQueries_AllOwners" )
						queryType = QueryType.AllOwners;
					else
					if ( e.Tool.Key == "menuQueries_AppointmentsByOwner" )
						queryType = QueryType.AppointmentsByOwner;

					frmQuery frmQuery = new frmQuery( this.DatabaseSupport, queryType );
					frmQuery.ShowDialog();

					break;
				}


				case "menuMain_File_Exit":
				{
					this.Close();
					break;
				}

			}
		}

		/// <summary>
		/// Handles the main form's Load event.
		/// </summary>
		private void frmMain_Load(object sender, System.EventArgs e)
		{
		}

		/// <summary>
		/// Handles the MouseDown event for the WinSchedule controls.
		/// </summary>
		private void WinScheduleControl_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if ( e.Button == MouseButtons.Right )
			{
				Point cursorPos = new Point( e.X, e.Y );
				Owner ownerAtPoint = null;
				UltraDayView dayView = sender as UltraDayView;
				UltraMonthViewSingleBase monthViewSingleBase = sender as UltraMonthViewSingleBase;

				if ( dayView != null )
					ownerAtPoint = dayView.GetOwnerFromPoint( cursorPos );
				else
				if ( monthViewSingleBase != null )
					ownerAtPoint = monthViewSingleBase.GetOwnerFromPoint( cursorPos );

				if ( ownerAtPoint != null )
				{
					this.menuItem_ModifyOwner.Tag = ownerAtPoint;
					this.menuItem_RemoveOwner.Tag = ownerAtPoint;
				}
			}
		}

		/// <summary>
		/// Handles the Click event for the context menu items.
		/// </summary>
		private void OnContextMenuItemClick( object sender, EventArgs e )
		{
			Owner owner = null;
			
			if ( sender == this.menuItem_ModifyOwner )
			{
				owner = this.menuItem_ModifyOwner.Tag as Owner;
				frmOwner frmOwner = new frmOwner( this.ultraCalendarInfo1 );
				frmOwner.Text = string.Format(Properties.Resources.ModifyOwner, owner.Name );
				frmOwner.ShowMe( owner );
				if ( frmOwner.DialogResult == DialogResult.OK )
				{
					owner.Key = frmOwner.Key;
					owner.Name = frmOwner.OwnerName;
					owner.EmailAddress = frmOwner.EMailAddress;
					owner.Visible = frmOwner.OwnerVisible;
					owner.Locked = frmOwner.Locked;
					this.InitializeOwnersPanel( true );
				}
			}
			else
			if ( sender == this.menuItem_RemoveOwner )
			{
				owner = this.menuItem_RemoveOwner.Tag as Owner;
				DialogResult result = MessageBox.Show( string.Format( Properties.Resources.RemoveOwnerMessage, owner.Name ), Properties.Resources.RemoveOwnerTitle, MessageBoxButtons.YesNo, MessageBoxIcon.Question );
 				if ( result == DialogResult.Yes )
				{
					this.ultraCalendarInfo1.Owners.Remove( owner );
					this.InitializeOwnersPanel( false );
				}
			}
		}

		/// <summary>
		/// Handles the CheckedChanged event for the checkboxes which represent Owners.
		/// </summary>
		private void OwnerCheckbox_CheckedChanged( object sender, EventArgs e )
		{
			UltraCheckEditor checkEditor = sender as UltraCheckEditor;
			Owner owner = checkEditor.Tag as Owner;
			owner.Visible = checkEditor.Checked;
		}

		/// <summary>
		/// Handles the UltraCalendarInfo component's 'ValidateAppointment' event.
		/// </summary>
		private void ultraCalendarInfo1_ValidateAppointment(object sender, Infragistics.Win.UltraWinSchedule.ValidateAppointmentEventArgs e)
		{
			//	Make sure the number of bytes needed to serialize the Appointment
			//	does not exceed the size of the 'AllProperties' field.
			byte[] appointmentBytes = e.Appointment.Save();
			if ( appointmentBytes != null &&
				 appointmentBytes.Length > WinScheduleDatabaseSupportBase.MAX_APPOINTMENT_BYTES )
			{
				e.Message = Properties.Resources.ValidateAppointmentMessage;
				e.CloseDialog = false;
			}
		}

		#endregion Event handlers

		#region Properties
			#region DatabaseSupport
		/// <summary>
		/// Returns an instance of the WinScheduleDatabaseSupportBase object
		/// that provides access to the Appointments and Owners tables.
		/// </summary>
		private WinScheduleDatabaseSupportBase DatabaseSupport
		{
			get
			{
				if ( this._databaseSupport == null )
				{
#if DATABASE_SQLSERVER
					this._databaseSupport = new WinScheduleMSSQLServerSupport();
#else
					this._databaseSupport = new WinScheduleMSAccessSupport();
#endif
				}
				return this._databaseSupport;
			}
		}
			#endregion DatabaseSupport

		#endregion Properties

		#region Methods

			#region InitializeUI
		/// <summary>
		/// Initialize the user interface by configuring controls, etc.
		/// </summary>
		private void InitializeUI()
		{
			//	Set the appointment grouping properties for the WinSchedule controls
			//	that support appointment grouping.
			this.ultraDayView1.GroupingStyle = DayViewGroupingStyle.OwnerWithinDate;
			this.ultraWeekView1.OwnerDisplayStyle = OwnerDisplayStyle.Separate;
			this.ultraWeekView1.MaximumOwnersInView = 2;
			this.ultraMonthViewSingle1.OwnerDisplayStyle = OwnerDisplayStyle.Separate;
			this.ultraMonthViewSingle1.MaximumOwnersInView = 2;
            this.ultraTimelineView1.OwnerGroupingStyle = TimelineViewOwnerGroupingStyle.Separate;
            this.ultraTimelineView1.MaximumOwnersInView = 2;

			//	Hide the unassigned owner
			this.ultraCalendarInfo1.Owners.UnassignedOwner.Visible = false;

			//	Set up data binding for Owners
			OwnersDataBinding ownersDataBinding = this.ultraCalendarInfo1.DataBindingsForOwners;
			ownersDataBinding.AllPropertiesMember = "AllProperties";
			ownersDataBinding.NameMember = "Name";
			ownersDataBinding.KeyMember = "OwnerKey";
			ownersDataBinding.VisibleMember = "Visible";
			ownersDataBinding.SetDataBinding( this.DatabaseSupport.DataSet, WinScheduleDatabaseSupportBase.OWNERS_TABLE_NAME );
			ownersDataBinding.BindingContextControl = this;
			ownersDataBinding.BindingContext = this.BindingContext;

			//	Set up data binding for Appointments
			AppointmentsDataBinding appointmentsDataBinding = this.ultraCalendarInfo1.DataBindingsForAppointments;
			appointmentsDataBinding.AllPropertiesMember = "AllProperties";
			appointmentsDataBinding.StartDateTimeMember = "StartDateTime";
			appointmentsDataBinding.EndDateTimeMember = "EndDateTime";
			appointmentsDataBinding.SubjectMember = "Subject";
			appointmentsDataBinding.AllDayEventMember = "AllDayEvent";
			appointmentsDataBinding.OwnerKeyMember = "OwnerKey";
			appointmentsDataBinding.SetDataBinding( this.DatabaseSupport.DataSet, WinScheduleDatabaseSupportBase.APPOINTMENTS_TABLE_NAME );
			appointmentsDataBinding.BindingContextControl = this;

			//	Handle the MouseDown event for the WinSchedule controls
			this.ultraDayView1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.WinScheduleControl_MouseDown);
            this.ultraWeekView1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.WinScheduleControl_MouseDown);
            this.ultraMonthViewSingle1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.WinScheduleControl_MouseDown);
            this.ultraTimelineView1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.WinScheduleControl_MouseDown);

			//	Configure the context menu, and assign the context menu to
			//	each of the WinSchedule controls
			this.menuItem_ModifyOwner = new Infragistics.Win.IGControls.IGMenuItem( Properties.Resources.ModifyOwnerMenu, new EventHandler(this.OnContextMenuItemClick) );
			this.menuItem_RemoveOwner = new Infragistics.Win.IGControls.IGMenuItem( Properties.Resources.RemoveOwnerMenu, new EventHandler(this.OnContextMenuItemClick) );
			this.contextMenu1.MenuItems.Add( this.menuItem_ModifyOwner );
			this.contextMenu1.MenuItems.Add( this.menuItem_RemoveOwner );
			this.ultraDayView1.ContextMenu = this.contextMenu1;
			this.ultraWeekView1.ContextMenu = this.contextMenu1;
            this.ultraMonthViewSingle1.ContextMenu = this.contextMenu1;
            this.ultraTimelineView1.ContextMenu = this.contextMenu1;

			//	Add a checkbox for each owner in the collection to the Panel control
			this.InitializeOwnersPanel( false );

			//	Initialize the dialog for the current view
			if ( this.ultraCalendarLook1.ViewStyle == ViewStyle.Office2007 )
			{
				Office2007ColorScheme colorScheme = Infragistics.Win.Office2007ColorTable.ColorScheme;
				string toolKey = string.Format("menuMain_View_Office2007_{0}", colorScheme );
				if ( this.ultraToolbarsManager1.Tools.Exists(toolKey) )
				{
					ToolBase tool = this.ultraToolbarsManager1.Tools[toolKey];
					this.ultraToolbarsManager1_ToolClick( this.ultraToolbarsManager1, new ToolClickEventArgs(tool, null) );
					
					//	Reserve the default color schemes; we will assign them to
					//	the Owner that was initially present in the database table.
					Outlook2007ColorSchemeCollection colorSchemes = this.ultraCalendarLook1.Outlook2007ColorSchemes;
					colorSchemes.DisallowAutoAssignment( colorSchemes.BaseColorBlue );
					colorSchemes.DisallowAutoAssignment( colorSchemes.BaseColorBlack );
				}
			}

		}
			#endregion InitializeUI

			#region InitializeOwnersPanel
		/// <summary>
		/// Adds checkboxes to the pnlOwners Panel control when 'refreshOnly' is false;
		/// when 'refreshOnly' is true, the existing ones are refreshed.
		/// </summary>
		private void InitializeOwnersPanel( bool refreshOnly )
		{
			if ( refreshOnly )
			{
				for ( int i = 0; i < this.pnlOwners.Controls.Count; i ++ )
				{
					UltraCheckEditor checkEditor = this.pnlOwners.Controls[i] as UltraCheckEditor;
					if ( checkEditor != null )
					{
						Owner owner = checkEditor.Tag as Owner;
						if ( checkEditor.Text != owner.Name )
							checkEditor.Text = owner.Name;

						if ( checkEditor.Checked != owner.Visible )
							checkEditor.Checked = owner.Visible;

					}
				}
			}
			else
			{
				this.pnlOwners.Controls.Clear();

				for ( int i = 0; i < this.ultraCalendarInfo1.Owners.Count; i ++ )
				{
					Owner owner = this.ultraCalendarInfo1.Owners[i];
					this.AddCheckboxForOwner( owner );
				}
			}
		}
			#endregion InitializeOwnersPanel

			#region AddCheckboxForOwner
		/// <summary>
		/// Adds an UltraCheckEditor control to the 'pnlOwners' control
		/// for the specified Owner.
		/// </summary>
		/// <param name="owner">The Owner for which a checkbox is to be added.</param>
		private void AddCheckboxForOwner( Owner owner )
		{
			int controlCount = this.pnlOwners.Controls.Count;
			int newTop = controlCount * 20;

			UltraCheckEditor checkEditor = new UltraCheckEditor();
			checkEditor.Text = owner.Name;
			checkEditor.Checked = owner.Visible;
			checkEditor.Tag = owner;
			checkEditor.Location = new Point( this.pnlOwners.Left + 2, newTop );
			checkEditor.Size = new Size( this.pnlOwners.Width - 5, 20 );
			this.pnlOwners.Controls.Add( checkEditor );
			checkEditor.BringToFront();
			checkEditor.CheckedChanged += new EventHandler( this.OwnerCheckbox_CheckedChanged );
		}
			#endregion AddCheckboxForOwner

			#region ShowScheduleControl
		/// <summary>
		/// Shows the specified UltraScheduleControlBase-derived control,
		/// and hides the others; also sets its Dock property to 'Fill'
		/// </summary>
		/// <param name="scheduleControl">The UltraScheduleControlBase-derived control to show.</param>
		private void ShowScheduleControl( UltraScheduleControlBase scheduleControl )
		{
			if ( scheduleControl != this.ultraDayView1 )
				this.ultraDayView1.Visible = false;

			if ( scheduleControl != this.ultraWeekView1 )
				this.ultraWeekView1.Visible = false;
	
			if ( scheduleControl != this.ultraMonthViewSingle1 )
				this.ultraMonthViewSingle1.Visible = false;

            if ( scheduleControl != this.ultraTimelineView1 )
                this.ultraTimelineView1.Visible = false;

			scheduleControl.Visible = true;
			scheduleControl.Dock = DockStyle.Fill;
		}
			#endregion ShowScheduleControl

		#endregion Methods

	}
	#endregion frmMain class
}
