using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;

namespace Infragistics.Win.UltraWinSchedule.Samples
{
	#region frmOwner class
	/// <summary>
	/// Dialog which enables the end user to add a new WinSchedule Owner
	/// or modify the properties of an existing one.
	/// </summary>
	public class frmOwner : System.Windows.Forms.Form
	{
		#region Member variables

		private Infragistics.Win.Misc.UltraButton cmdOk;
		private Infragistics.Win.Misc.UltraButton cmdCancel;
		private System.ComponentModel.Container components = null;
		private Owner _owner = null;
		private Infragistics.Win.UltraWinEditors.UltraCheckEditor chkLocked;
		private Infragistics.Win.UltraWinEditors.UltraCheckEditor chkVisible;
		private Infragistics.Win.Misc.UltraLabel lblEmail;
		private Infragistics.Win.UltraWinEditors.UltraTextEditor txtEmail;
		private Infragistics.Win.Misc.UltraLabel lblName;
		private Infragistics.Win.UltraWinEditors.UltraTextEditor txtName;
		private Infragistics.Win.Misc.UltraLabel lblKey;
		private Infragistics.Win.UltraWinEditors.UltraTextEditor txtKey;
		UltraCalendarInfo calendarInfo = null;

		#endregion Member variables

		#region Constructor
		/// <summary>
		/// Creates a new instance of the <see cref="frmOwner"/> class.
		/// </summary>
		/// <param name="calendarInfo">The UltraCalendarInfo instance to which this dialog is associated.</param>
		public frmOwner( UltraCalendarInfo calendarInfo )
		{
			this.calendarInfo = calendarInfo;
			InitializeComponent();
		}
		#endregion Constructor

		#region Windows Form Designer generated code
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(frmOwner));
            Infragistics.Win.Appearance appearance1 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance2 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance3 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance4 = new Infragistics.Win.Appearance();
            Infragistics.Win.Appearance appearance5 = new Infragistics.Win.Appearance();
            this.chkLocked = new Infragistics.Win.UltraWinEditors.UltraCheckEditor();
            this.chkVisible = new Infragistics.Win.UltraWinEditors.UltraCheckEditor();
            this.lblEmail = new Infragistics.Win.Misc.UltraLabel();
            this.txtEmail = new Infragistics.Win.UltraWinEditors.UltraTextEditor();
            this.lblName = new Infragistics.Win.Misc.UltraLabel();
            this.txtName = new Infragistics.Win.UltraWinEditors.UltraTextEditor();
            this.lblKey = new Infragistics.Win.Misc.UltraLabel();
            this.txtKey = new Infragistics.Win.UltraWinEditors.UltraTextEditor();
            this.cmdOk = new Infragistics.Win.Misc.UltraButton();
            this.cmdCancel = new Infragistics.Win.Misc.UltraButton();
            ((System.ComponentModel.ISupportInitialize)(this.chkLocked)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.chkVisible)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.txtEmail)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.txtName)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.txtKey)).BeginInit();
            this.SuspendLayout();
            // 
            // chkLocked
            // 
            resources.ApplyResources(this.chkLocked, "chkLocked");
            appearance1.BackColor = System.Drawing.Color.Transparent;
            resources.ApplyResources(appearance1, "appearance1");
            this.chkLocked.Appearance = appearance1;
            this.chkLocked.BackColor = System.Drawing.Color.Transparent;
            this.chkLocked.BackColorInternal = System.Drawing.Color.Transparent;
            this.chkLocked.Name = "chkLocked";
            // 
            // chkVisible
            // 
            resources.ApplyResources(this.chkVisible, "chkVisible");
            appearance2.BackColor = System.Drawing.Color.Transparent;
            resources.ApplyResources(appearance2, "appearance2");
            this.chkVisible.Appearance = appearance2;
            this.chkVisible.BackColor = System.Drawing.Color.Transparent;
            this.chkVisible.BackColorInternal = System.Drawing.Color.Transparent;
            this.chkVisible.Name = "chkVisible";
            // 
            // lblEmail
            // 
            resources.ApplyResources(this.lblEmail, "lblEmail");
            appearance3.BackColor = System.Drawing.Color.Transparent;
            resources.ApplyResources(appearance3, "appearance3");
            this.lblEmail.Appearance = appearance3;
            this.lblEmail.Name = "lblEmail";
            // 
            // txtEmail
            // 
            resources.ApplyResources(this.txtEmail, "txtEmail");
            this.txtEmail.Name = "txtEmail";
            // 
            // lblName
            // 
            resources.ApplyResources(this.lblName, "lblName");
            appearance4.BackColor = System.Drawing.Color.Transparent;
            resources.ApplyResources(appearance4, "appearance4");
            this.lblName.Appearance = appearance4;
            this.lblName.Name = "lblName";
            // 
            // txtName
            // 
            resources.ApplyResources(this.txtName, "txtName");
            this.txtName.Name = "txtName";
            // 
            // lblKey
            // 
            resources.ApplyResources(this.lblKey, "lblKey");
            appearance5.BackColor = System.Drawing.Color.Transparent;
            resources.ApplyResources(appearance5, "appearance5");
            this.lblKey.Appearance = appearance5;
            this.lblKey.Name = "lblKey";
            // 
            // txtKey
            // 
            resources.ApplyResources(this.txtKey, "txtKey");
            this.txtKey.Name = "txtKey";
            // 
            // cmdOk
            // 
            resources.ApplyResources(this.cmdOk, "cmdOk");
            this.cmdOk.Name = "cmdOk";
            this.cmdOk.Click += new System.EventHandler(this.cmdOk_Click);
            // 
            // cmdCancel
            // 
            resources.ApplyResources(this.cmdCancel, "cmdCancel");
            this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.cmdCancel.Name = "cmdCancel";
            this.cmdCancel.Click += new System.EventHandler(this.cmdCancel_Click);
            // 
            // frmOwner
            // 
            this.AcceptButton = this.cmdOk;
            resources.ApplyResources(this, "$this");
            this.CancelButton = this.cmdCancel;
            this.Controls.Add(this.chkLocked);
            this.Controls.Add(this.chkVisible);
            this.Controls.Add(this.lblEmail);
            this.Controls.Add(this.txtEmail);
            this.Controls.Add(this.lblName);
            this.Controls.Add(this.txtName);
            this.Controls.Add(this.lblKey);
            this.Controls.Add(this.txtKey);
            this.Controls.Add(this.cmdOk);
            this.Controls.Add(this.cmdCancel);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "frmOwner";
            ((System.ComponentModel.ISupportInitialize)(this.chkLocked)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.chkVisible)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.txtEmail)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.txtName)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.txtKey)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		#region Event handlers
		
		/// <summary>
		/// Handles the Ok button's Click event
		/// </summary>
		private void cmdOk_Click(object sender, System.EventArgs e)
		{
			if ( this.ValidateKey() == false )
				return;

			this.DialogResult = DialogResult.OK;
			this.Close();
		}

		/// <summary>
		/// Handles the Cancel button's Click event
		/// </summary>
		private void cmdCancel_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.Cancel;		
			this.Close();
		}

		/// <summary>
		/// Handles the appropriate "value changed" event for all controls
		/// on the dialog which represent Owner properties.
		/// </summary>
		private void OnFieldValueChanged( object sender, EventArgs e )
		{
			this.cmdOk.Enabled = true;
		}

		#endregion Event handlers

		#region ShowMe
		/// <summary>
		/// Shows the dialog
		/// </summary>
		/// <param name="owner">The Owner being edited, or null if adding a new Owner.</param>
		public void ShowMe( Owner owner )
		{
			this._owner = owner;
			this.txtKey.Text = string.Empty;
			this.txtName.Text = string.Empty;
			this.txtEmail.Text = string.Empty;
			this.chkVisible.Checked = true;
			this.chkLocked.Checked = false;
			this.cmdOk.Enabled = false;
			this.Text = Properties.Resources.AddOwner;

			this.txtKey.MaxLength = 50;
			this.txtName.MaxLength = 50;
			this.txtEmail.MaxLength = 50;

			if ( this._owner != null )
			{
				this.txtKey.Text = owner.Key;
				this.txtName.Text = owner.Name;
				this.txtEmail.Text = owner.EmailAddress;
				this.chkVisible.Checked = owner.Visible;
				this.chkLocked.Checked = owner.Locked;
				this.Text = string.Format( Properties.Resources.ModifyProperties, owner.Name );
			}

			this.StartPosition = FormStartPosition.CenterParent;

			this.txtKey.TextChanged += new EventHandler( this.OnFieldValueChanged );
			this.txtName.TextChanged += new EventHandler( this.OnFieldValueChanged );
			this.txtEmail.TextChanged += new EventHandler( this.OnFieldValueChanged );
			this.chkLocked.CheckedChanged += new EventHandler( this.OnFieldValueChanged );
			this.chkVisible.CheckedChanged += new EventHandler( this.OnFieldValueChanged );

			this.ShowDialog();
		}

		#endregion ShowMe

		#region ValidateKey
		/// <summary>
		/// Validates the 'Key' field by ensuring the key is non-empty and unique.
		/// </summary>
		private bool ValidateKey()
		{
			bool keyOk = true;
			if ( this.txtKey.Text.Length == 0 )
			{
				MessageBox.Show( "Must specify key.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error );
				keyOk = false;
			}
			else
			{
				if ( this.calendarInfo.Owners.Exists(this.txtKey.Text) )
				{
					//	If the specified key exists, and we are adding a new owner,
					//	fail the validation.
					if ( this._owner == null )
						keyOk = false;
					else
					//	If the specified key exists, we are modifying an existing owner,
					//	and the specified key is different than this owner's fail the validation.
					if ( this.txtKey.Text.Equals(this._owner.Key) == false )
						keyOk = false;
				}
			}

			if ( keyOk == false )
			{
				this.txtKey.Select();
				MessageBox.Show( "Specified key already exists.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error );
			}

			return keyOk;
		}
		#endregion ValidateKey

		#region Key
		/// <summary>
		/// Returns the value of the 'Key' field.
		/// </summary>
		public string Key
		{
			get{ return this.txtKey.Text; }
		}
		#endregion Key

		#region OwnerName
		/// <summary>
		/// Returns the value of the 'Name' field.
		/// </summary>
		public string OwnerName
		{
			get{ return this.txtName.Text; }
		}
		#endregion OwnerName

		#region EMailAddress
		/// <summary>
		/// Returns the value of the 'Email' field.
		/// </summary>
		public string EMailAddress
		{
			get{ return this.txtEmail.Text; }
		}
		#endregion EMailAddress

		#region OwnerVisible
		/// <summary>
		/// Returns the value of the 'Visible' field.
		/// </summary>
		public bool OwnerVisible
		{
			get{ return this.chkVisible.Checked; }
		}
		#endregion OwnerVisible

		#region Locked
		/// <summary>
		/// Returns the value of the 'Locked' field.
		/// </summary>
		public bool Locked
		{
			get{ return this.chkLocked.Checked; }
		}
		#endregion Locked
	}
	#endregion frmOwner class
}
